2013-04-12  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/subcommands/setup_command.rb (BitClust::SetupCommand#checkout):
	use result of system directly instead of calling "svn help" with
	redirects. because it may cause permission problem on cygwin.
	see https://twitter.com/higaki/status/322542075927212034

2013-04-06  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/nameutils.rb
	(BitClust::NameUtils::CLASS_NAME_RE): support main and
	*::compatible class. (see #8186)
	(BitClust::NameUtils::CLASS_PATH_RE): ditto.

2012-10-09  Ippei Obayashi  <ohai@kmc.gr.jp>

	* lib/bitclust/subcommands/server_command.rb
	(BitClust::Subcommands::ServerCommand#initialize): fix set_srcdir call
	(BitClust::Subcommands::ServerCommand#srcdir_root): fix default srcdir

2012-09-24  okkez  <okkez000@gmail.com>

	* lib/bitclust/subcommand.rb: split subcommands.

	* lib/bitclust/subcommands/update_command.rb: split update
	subcommand.

	* lib/bitclust/subcommands/setup_command.rb: split setup
	subcommand.

	* lib/bitclust/subcommands/server_command.rb: split server
	subcommand.

	* lib/bitclust/subcommands/query_command.rb: split query
	subcommand.

	* lib/bitclust/subcommands/property_command.rb: split property
	subcommand.

	* lib/bitclust/subcommands/lookup_command.rb: split lookup
	subcommand.

	* lib/bitclust/subcommands/list_command.rb: split list subcommand.

	* lib/bitclust/subcommands/init_command.rb: split init subcommand.

2012-09-16  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/subcommand.rb (BitClust::SetupCommand#checkout):
	  check svn installed Windows, too. (see #7026)

2012-09-15  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/subcommand.rb (BitClust::ServerCommand#exec): start
	  browser mingw, cygwin and bccwin. (same as r5167)

2012-09-02  okkez  <okkez000@gmail.com>

	* lib/bitclust/subcommand.rb (BitClust::SetupCommand#prepare): do
	not overwrite config.yml if exist it. fix #6949

2012-08-26  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/subcommand.rb (BitClust::ServerCommand#initialize):
	  add :BindAddress to @params to delete warning.

2012-08-25  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/runner.rb: do not push Pathname object to
	  $LOAD_PATH. (fixes #6925)

2012-08-25  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/subcommand.rb (BitClust::ServerCommand#parse): fix
	  instance method reference. (fixes #6924)

2012-08-25  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/nameutils.rb (BitClust::NameUtils): add #!~ to
	  methodname (fixes #6915)

2012-08-15  okkez  <okkez000@gmail.com>

	* standalone.rb: remove unused file.

2012-08-12  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/classentry.rb (BitClust::ClassEntry#superclass):
	  enable to return superclass from alias class. (see #6826)

2012-08-11  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/subcommand.rb (BitClust::SetupCommand#prepare): fix
	  typo. thanks dice (fixes #6856)

2012-08-07  Sho Hashimoto  <sho-h@netlab.jp>

	* tools/bc-tohtmlpackage.rb (#main): support multi name
	  method. (see #5257)
	  (#create_html_file): ditto.
	  (#create_html_method_file): ditto.

2012-06-04  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/completion.rb
	  (BitClust::Completion::search_methods_from_mname): remove unused
	  line. (fixes #6542)

2012-06-01  Sho Hashimoto  <sho-h@netlab.jp>

	* data/bitclust/template.lillia/library: display all error
	  classes. (see #6350)

	* data/bitclust/template.offline/library: ditto.

	* data/bitclust/template/library: ditto.

2012-06-01  Sho Hashimoto  <sho-h@netlab.jp>

	* data/bitclust/template.lillia/library: display all classes.
	  (see #6350)

	* data/bitclust/template.offline/library: ditto.

	* data/bitclust/template/library: ditto.

2012-05-27  wanabe  <s.wanabe@gmail.com>

	* data/bitclust/template.offline/class: update to keep with template/.
	  fix #5944. see #5503.

	* data/bitclust/template.offline/library: ditto.

2012-05-25  Sho Hashimoto  <sho-h@netlab.jp>

	* tools/bc-tohtmlpackage.rb (main): do not copy .svn in images.

2012-05-23  Sho Hashimoto  <sho-h@netlab.jp>

	* standalone.rb: start browser mingw, cygwin and bccwin.
	  (fixes #6461)

2012-02-29  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: add bitclust_libdir to avoid LoadError in bin/bitclust.

2012-02-12  wanabe  <s.wanabe@gmail.com>

	* data/bitclust/template/library: sort classes according to
	inheritance hierarchy. #5943

	* data/bitclust/template.offline/library: ditto.

	* data/bitclust/template.lillia/library: ditto.

	* data/bitclust/catalog/ja_JP.EUC-JP: add "Classes", "Modules" and
	"Objects".


2011-12-19  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* bitclust.gemspec, packer.rb: change from redmine.ruby-lang.org
	to bugs.ruby-lang.org.

2011-12-19  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: follow rename at r4950.

2011-12-17  okkez  <okkez000gmail.com>

	* lib/bitclust/subcommand (BitClust::ServerCommand): add.

2011-12-15  okkez  <okkez000gmail.com>

	* lib/bitclust/subcommand: move subcommand classes under BitClust
	module.

2011-12-12  okkez  <okkez000gmail.com>

	* bin/bitclust: split subcommands from bin/bitclust.
	* lib/bitclust/subcommand: split subcommands from bin/bitclust.

2011-12-11  okkez  <okkez000@gmail.com>

	* bin/bitclust (SetupCommand): add.
	(#_main): add --version option.
	(#_main): read config from $HOME/.bitclust/config.
	(#_main): add --target option.

2011-10-31  okkez  <okkez000@gmail.com>

	* standalone.rb: add srcdir_root method and use it.

	* bin/bitclust.rb (PropertyCommand#exec): bin/bitclust.rb is a
	command line tool.

	* Rakefile: add gem related tasks.

	* lib/bitclust/version.rb: add.

	* bitclust.gemspec (Gem): add.

	* Gemfile: add.

2011-08-14  okkez  <okkez000@gmail.com>

	* lib/bitclust/rdcompiler.rb
	(BitClust::RDCompiler#method_entry_chunk): compile @todo.
	(BitClust::RDCompiler#todo): add.

	* lib/bitclust/preprocessor.rb (BitClust::Preprocessor#next_line):
	preprocess #@todo to @todo.

2011-07-18  okkez  <okkez000@gmail.com>

	* packer.rb (#system_verbose): fix deprecated links. fixes #5040

2011-07-17  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/refsdatabase.rb
	(BitClust::RefsDatabase#extract): allow level 5 and 6 refs.
	(fixes #5035)

2011-06-21  okkez  <okkez000@gmail.com>

	* lib/bitclust/libraryentry.rb
	(BitClust::LibraryEntry#sublibrary): do not append duplicate
	sublibraries. fixes #4901

2011-06-10  okkez  <okkez000@gmail.com>

	* tools/forall-ruby.rb (#main): remove GEM_HOME environment
	variable.

2011-06-01  okkez  <okkez000@gmail.com>

	* lib/bitclust/crossrubyutils.rb
	(BitClust::CrossRubyUtils#forall_ruby): reject rvm's gemset.
	(BitClust::CrossRubyUtils#build_crossruby_table): remove GEM_HOME
	environment variable.
	(BitClust::CrossRubyUtils#print_table): beautify table content.

2011-04-29  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: make *.tar.xz instead of *.tar.bz2.

2011-02-13  okkez  <okkez000@gmail.com>

	* tools/bc-tohtmlpackage.rb: set Encoding.default_external.

	* lib/bitclust.rb: do not set Encoding.default_external.

2011-02-12  okkez  <okkez000@gmail.com>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler#method_info):
	unset Regexp 'n' option to reduce warnings when Ruby1.9.

	* lib/bitclust.rb: set Encoding.default_external = 'euc-jp'.

	* tools/bc-convert.rb: do not set $KCODE when Ruby1.9.

	* tools/bc-tohtml.rb: ditto.

	* config.in: ditto.

	* bin/bitclust.rb (#srcdir_root): reduce warnings.

	* lib/bitclust/parseutils.rb (BitClust::LineStream#gets):
	StrintIO#path is removed after Ruby1.9.

	* Rakefile: add.

	* test/run_test.rb: add.

2011-02-11  okkez  <okkez000@gmail.com>

	* tools/bc-tohtml.rb (#main): fix template path.

	* template.offline: move to ...

	* data/bitclust/template.offline: ... this.

2010-10-28  okkez  <okkez000@gmail.com>

	* server.rb: now can see C API

	* packer.rb (#system_verbose): change URI of "rurema wiki" (fix #3885)

2010-09-29  okkez  <okkez000@gmail.com>

	* packer.rb: bump version 1.9.1 -> 1.9.2

2010-06-27  Sho Hashimoto  <sho-h@netlab.jp>

	* lib/bitclust/screen.rb (BitClust::URLMapper#document_url): allow
	'-' to document_url.

2010-06-25  okkez  <okkez000@gmail.com>

	* theme/default/style.css: remove attributes align, valign (fix #55)

	* theme/lillia/style.css: ditto.

2010-06-21  okkez  <okkez000@gmail.com>

	* tools/bc-checkparams.rb: add a tool to check difference between
	signature and @param list.

2010-05-02  okkez  <okkez000@gmail.com>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler#bracket_link):
	now can handle type 'f' bracket link.

	* test/test_rdcompiler.rb (TestRDCompiler#test_bracket_link): fix
	typo and add test for type 'f' bracket link.

	* data/bitclust/template.lillia/layout: apply layout to lillia theme.

	* data/bitclust/template.lillia/class: ditto.

	* data/bitclust/template.lillia/class-index: ditto.

	* data/bitclust/template.lillia/doc: ditto.

	* data/bitclust/template.lillia/library: ditto.

	* data/bitclust/template.lillia/library-index: ditto.

	* data/bitclust/template.lillia/method: ditto.

	* data/bitclust/template.lillia/rd_file: ditto.

2010-04-18  wanabe  <s.wanabe@gmail.com>

	* lib/bitclust/searcher.rb: add require 'functiondatabase'.
	  a patch from Ippei Obayashi (fix #3166).

2010-04-15  wanabe  <s.wanabe@gmail.com>

	* tools/bc-tohtml.rb (main): enable 'bc-tohtml --capi file --target=NAME'.
	  (lookup): accept function name when C API mode.

	* lib/bitclust/functionreferenceparser.rb (FunctionReferenceParser.parse_file):
	  added.
	  (FunctionReferenceParser#parse): return array of functions.

	* template.offline/function: added.

2010-04-10  wanabe  <s.wanabe@gmail.com>

	* standalone.rb: enable 'ruby standalone.rb --baseurl=URL
	  {--auto|--database=PATH} --capi'.

	* lib/bitclust/app.rb (BitClust::App#initialize): enable to pass
	  FunctionDatabase to request handler.

	* lib/bitclust/requesthandler.rb: save FunctionDatabase and use.

2010-04-09  okkez  <okkez000@gmail.com>

	* tools/bc-methods.rb (#main): avoid tracer.

2010-04-08  okkez  <okkez000@gmail.com>

	* tools/bc-rdoc.rb (DiffCommand#parse): use
	BitClust::MethodDatabase instead of BitClust::Database

2010-04-01  okkez  <okkez000@gmail.com>

	* data/bitclust/template/layout: apply layout.

	* data/bitclust/template/search: ditto.

	* data/bitclust/template/library-index: ditto.

	* data/bitclust/template/library: ditto.

	* data/bitclust/template/function-index: ditto.

	* data/bitclust/template/function: ditto.

	* data/bitclust/template/doc: ditto.

	* data/bitclust/template/class-index: ditto.

	* data/bitclust/template/class: ditto.

	* data/bitclust/template/method: ditto.

	* lib/bitclust/screen.rb (BitClust::TemplateScreen#run_template): ditto.

2010-03-30  wanabe  <s.wanabe@gmail.com>

	* lib/bitclust/searcher.rb: enable "bitclust --capi search [NAME]".

	* lib/bitclust/functiondatabase.rb(search_functions): add.

	* lib/bitclust/completion.rb (_search_functions): add for completion.

	* lib/bitclust/functionentry.rb (name_match?): ditto.

2010-03-29  wanabe  <s.wanabe@gmail.com>

	* bin/bitclust.rb (LookupCommand): enable "bitclust --capi lookup
	  --function".

	* lib/bitclust/functionentry.rb (BitClust::FunctionEntry): new alias
	  kind -> type_label.

	* test/test_bitclust.rb: add test for above.

2010-03-28  wanabe  <s.wanabe@gmail.com>

	* bin/bitclust.rb (ListCommand): enable "bitclust --capi list --function".

	* test/test_bitclust.rb: add test of bin/bitclust.rb.

	* test/db-test/: add DB for test.

2010-03-25  Sho Hashimoto  <sho-h@netlab.jp>

	* data/bitclust/template/method: translate topic path.

	* template.offline/method: ditto.

2009-12-14  okkez  <okkez000@gmail.com>

	* data/bitclust/template/search: display elapsed time.

	* lib/bitclust/requesthandler.rb
	(BitClust::RequestHandler#handle_search): ditto.

	* lib/bitclust/screen.rb (BitClust::SearchScreen#initialize): ditto.

	* tools/bc-tohtmlpackage.rb (#main): copy images to output directory.

	* theme/default/style.css: fix style problems.

2009-10-13  okkez  <okkez000@gmail.com>

	* lib/bitclust/requesthandler.rb
	(BitClust::RackRequestHandler#handle): rescue
	BitClust::NotFoundError and return not_found_response.

2009-09-14  okkez  <okkez000@gmail.com>

	* lib/bitclust/exception.rb (BitClust::NotFoundError): add new
	error.
	(BitClust::LibraryNotFound, BitClust::ClassNotFound)
	(BitClust::MethodNotFound, BitClust::FunctionNotFound)
	(BitClust::DocNotFound): change super class UserError to NotFoundError.

	* lib/bitclust/screen.rb (BitClust::NotFoundScreen): add new
	screen.

	* lib/bitclust/requesthandler.rb
	(BitClust::RequestHandler#handle_method): raise MethodNotFound
	when cannot fetch methods.
	(BitClust::RequestHandler#handle): handle BitClust::NotFoundError.

2009-08-08  okkez  <okkez000@gmail.com>

	* lib/bitclust/completion.rb
	(BitClust::Completion#search_methods_from_mname): handle module
	function correctly. a patch from Ippei Obayashi (fix #1409).
	(BitClust::Completion#mspec_from_cref_mname): add new method.

2009-07-22  okkez  <okkez000@gmail.com>

	* test/test_rdcompiler.rb: add require 'methoddatabase' (see #1770)

2009-07-15  okkez  <okkez000@gmail.com>

	* test/test_rdcompiler.rb (TestRDCompiler#test_method): add css classes.
	(TestRDCompiler#test_method2): ditto.

	* lib/bitclust/rdcompiler.rb
	(BitClust::RDCompiler#method_entry_chunk): remove needless space.

2009-07-15  okkez  <okkez000@gmail.com>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler#man_link):
	remove needless space.

	* test/test_rdcompiler.rb (TestRDCompiler#test_braket_link): ditto.

2009-07-10  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler#see): do not
	  split [[m:$,]] (closes #1754)

	* test/test_rdcompiler.rb (TestRDCompiler#test_array_join): add a
	  test.

2009-07-04  okkez  <okkez000@gmail.com>

	* theme/default/images/external.png: add svn:mime-type image/png.

2009-07-04  okkez  <okkez000@gmail.com>

	* theme/default/style.css: add style "a.external".

	* theme/default/images/external.png: add a png image.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler#direct_url)
	(BitClust::RDCompiler#blade_link, BitClust::RDCompiler#rfc_link)
	(BitClust::RDCompiler#man_link): add "external" css class.

2009-07-04  okkez  <okkez000@gmail.com>

	* lib/bitclust/rdcompiler.rb: trim spaces.

	* lib/bitclust/app.rb: ditto.

2009-06-25  okkez  <okkez000@gmail.com>

	* tools/bc-ancestors.rb: add new tool.

2009-06-04  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/methodsignature.rb
	(BitClust::MethodSignature#friendly_string): `command` should
	  treat as a special case. (closes #1561)

	* test/test_methodsignature.rb: add tests.

2009-05-03  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* data/bitclust/template/library: add a missing </tr>.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::bracket_link): 
	  use readable labels for '/' and '_builtin'.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::initialize): 
	  use a hash to pass catalog to rdcompiler.

	* lib/bitclust/screen.rb (BitClust::DocScreen::rdcompiler) 
	* lib/bitclust/screen.rb (BitClust::TemplateScreen::rdcompiler): ditto.

2009-04-25  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* data/bitclust/template.lillia/: 
	  add the system identifier of HTML 4.01 to templates.

	* data/bitclust/template.lillia/library:
	  use added methods.

	* lib/bitclust/libraryentry.rb (BitClust::LibraryEntry::all_classes):
	(BitClust::LibraryEntry::all_error_classes): 
	  add new methods.

	* lib/bitclust/screen.rb (BitClust::TemplateScreen::compile_method): 
	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::method_signature): 
	  (BitClust::RDCompiler::compile_method): 
	  compile_method now can take an option.

	* theme/lillia/: 
	* data/bitclust/template.lillia: 
	  add a theme and a template.

	* lib/bitclust/app.rb (BitClust::App::initialize):   add new options.
	* standalone.rb: ditto.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler): 
	  set class to html elemets.

	* lib/bitclust/screen.rb (BitClust::URLMapper::js_url): add a new method.
	* lib/bitclust/screen.rb (BitClust::TemplateScreen::js_url): ditto.
	* lib/bitclust/libraryentry.rb (BitClust::LibraryEntry::error_classes): ditto.
	* lib/bitclust/docentry.rb (BitClust::DocEntry): ditto.

2009-04-20  okkez  <okkez000@gmail.com>

	* template.offline/rd_file: change to the same design as template for online.

	* template.offline/method: ditto.

	* template.offline/library-index: ditto.

	* template.offline/library: ditto.

	* template.offline/doc: ditto.

	* template.offline/class-index: ditto.

	* template.offline/class: ditto.

2009-04-20  okkez  <okkez000@gmail.com>

	* data/bitclust/template/function-index: fix classes.

	* data/bitclust/template/library-index: ditto.

	* data/bitclust/template/library: ditto.

2009-04-20  okkez  <okkez000@gmail.com>

	* tools/bc-tohtmlpackage.rb: change default output directory.

	* tools/bc-tohtmlpackage.rb: create output directory if it doesn't exist.

	* tools/bc-tochm.rb: ditto.

2009-04-20  okkez  <okkez000@gmail.com>

	* tools/bc-tohtmlpackage.rb: add favicon. trim white spaces.


2009-04-20  okkez  <okkez000@gmail.com>

	* tools/bc-tochm.rb: set svn:executable.

	* tools/bc-tohtmlpackage.rb: ditto.

	* tools/stattodo.rb: ditto.

2009-04-20  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* data/bitclust/template/*: remove / because there are not XHTML.

2009-04-18  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* tools/bc-tohtmlpackage.rb
	  add a tool to create an html package.
	
	* tools/bc-tohtmlpackage.rb (encodename_package): 
	  Add an option, --fs-casesensitive, which allow case-sensitive file names.

2009-04-17  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/methodsignature.rb, lib/bitclust/nameutils.rb,
	  test/test_nameutils.rb: fix unary operator signature (fix #1384)

2009-04-17  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/screen.rb, theme/default/rurema.png,
	  data/bitclust/template/*: add favicon.

2009-03-15  okkez  <okkez000@gmail.com>

	* config.ru.sample: Add another sample of config.ru for rackup command.

2009-03-15  okkez  <okkez000@gmail.com>

	* standalone.rb: fix mount point.

	* lib/bitclust/app.rb (BitClust::App#service): fix redirect (fix #1228)

	* lib/bitclust/app.rb (BitClust::App#initialize): fix multi
	version's viewpath.

	* lib/bitclust/app.rb (BitClust::App#index): fix redirect.

2009-02-24  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/screen.rb, lib/bitclust/requesthandler.rb,
	  data/bitclust/template/*: add opensearchdescription.

2009-02-13  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: add -Ke to `bitclust init` and `bitclust update` too.

	* config.ru: auto search themedir.

2008-12-08  okkez  <okkez000@gmail.com>

	* standalone.rb: Fix view_path.

	* lib/bitclust/app.rb (BitClust::App#initialize): Fix :cgi_url.

2008-11-03  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* config.ru, standalone.rb, lib/bitclust/app.rb,
	  lib/bitclust/interface.rb,
	  lib/bitclust/requesthandler.rb, standalone.rb:
	  support rack.

	* lib/bitclust/compat.rb, lib/bitclust/requesthandler.rb:
	  use bytesize instead of size.

2008-08-31  okkez  <okkez000@gmail.com>

	* lib/bitclust/methodsignature.rb (BitClust::MethodSignature):
	  fix regexp to match '-> ()' (fix #521)

2008-08-29  okkez  <okkez000@gmail.com>

	* tools/bc-tochm.rb (#main): use BitClust::MethodDatabase instead
	  BitClust::Database
	* tools/bc-tochm.rb (#main): template -> data/bitclust/template

2008-08-26  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* standalone.rb: do not mount '/' twice when --auto.

2008-08-23  Yutaka HARA  <yhara.at.kmc.gr.jp>

	* bin/standalone.rb: redirect '/' to '#{basepath}/view/'.

Sat Aug 16 15:49:16 2008  Minero Aoki  <aamine@loveruby.net>

	* theme/default/style.css: table should always printed in 100%
	  width.

	* data/bitclust/template/*: <table>s participate in the entries
	  class.

	* lib/bitclust/methodsignature.rb: gvar should be shown as
	  "$gvar", not "self $gvar".

Sat Aug 16 15:07:23 2008  Minero Aoki  <aamine@loveruby.net>

	* theme/default/style.css: make method links a block, to widen
	  clickable area. (refs #177)

	* data/bitclust/template/class: locate only one anchor for one
	  <td>.

	* lib/bitclust/htmlutils.rb: new method #method_url.

Fri Aug 15 02:21:17 2008  Minero Aoki  <aamine@loveruby.net>

	* data/bitclust/template/search: method parameters were wrongly
	  shown.

Fri Aug 15 02:11:40 2008  Minero Aoki  <aamine@loveruby.net>

	* data/bitclust/template/search: translate topic path.

Fri Aug 15 02:10:12 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb: new method friendly_library_name.

	* data/bitclust/template/library: do not link to current page in
	  topic path.

	* data/bitclust/template/class: translate "ancestors".

	* lib/bitclust/screen.rb: translate search button label.

	* data/bitclust/catalog/ja_JP.EUC-JP: more translation.

	* data/bitclust/template/search: fix syntax error.

Fri Aug 15 01:16:48 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb: add utility methods #manual_home_link
	  and #friendly_library_link.

	* tools/gencatalog.rb: strip "\n" from catalog keys and values.

	* data/bitclust/template/*: translate topic-path.

	* data/bitclust/catalog/ja_JP.EUC-JP: more translation.

Fri Aug 15 01:15:01 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/htmlutils.rb: refactoring.

Fri Aug 15 00:36:23 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb (default_message_catalog): :datadir
	  includes "bitclust/" prefix.

Thu Aug 14 23:45:42 2008  Minero Aoki  <aamine@loveruby.net>

	* standalone.rb: templatedir -> datadir.

Thu Aug 14 22:44:47 2008  Minero Aoki  <aamine@loveruby.net>

	* template -> data/bitclust/template

	* catalog -> data/bitclust/catalog

Thu Aug 14 22:42:18 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/messagecatalog.rb: new file.

	* lib/bitclust/screen.rb: make messages translatable by
	  MessageCatalog.

	* lib/bitclust/rdcompiler.rb: receive a MessageCatalog (but not
	  used yet).

	* template/*: translate messages.

	* catalog/ja_JP.EUC-JP: new file.

	* config.in: new configuration parameter :catalogdir.

	* config.in: new configuration parameter :datadir.

	* tools/gencatalog.rb: new tool to generate message translation
	  catalog file from source codes.

Wed Aug 13 14:16:41 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/methodsignature.rb (friendly_string): show return
	  types for also unary/binary operators.

Wed Aug 13 13:59:21 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/methodsignature.rb: new class MethodSignature,
	  which represents RRD method signature line ("--- m(param) {...} ->
	  type").

	* lib/bitclust/screen.rb (foreach_method_chunk): yields a
	  MethodSignature to the template.

	* lib/bitclust/rdcompiler.rb (method_signature): show method
	  signature in user-friendly form ("x + y" rather than "+(y)").
	  (refs #170)

	* template/class: ditto.

	* lib/bitclust/rdcompiler.rb (method_signature): makes the whole
	  signature a hyperlink. (refs #188)

	* template/class: ditto.

	* template/search: ditto.

	* tools/check-signature.rb: a new tool to check method signature
	  format.

Tue Aug 12 18:55:06 2008  Minero Aoki  <aamine@loveruby.net>

	* config.in: use MethodDatabase instead of Database.

Tue Aug 12 18:54:18 2008  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb: use MethodDatabase.

Tue Aug 12 18:29:16 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/methoddatabase.rb: LoadError fixed.

	* lib/bitclust/functiondatabase.rb: ditto.

	* lib/bitclust/server.rb: ditto.

	* lib/bitclust/libraryentry.rb: fix typo.

Tue Aug 12 18:22:16 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/entry.rb: split file.

	* lib/bitclust/libraryentry.rb: new file.

	* lib/bitclust/classentry.rb: new file.

	* lib/bitclust/methodentry.rb: new file.

	* lib/bitclust/functionentry.rb: new file.

	* lib/bitclust/docentry.rb: new file.

Tue Aug 12 18:03:32 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust.rb: should require bitclust/*database.rb.
	  (refs #422)

	* lib/bitclust/server.rb: ditto.

Tue Aug 12 17:56:27 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/completion.rb (search_methods_by_cname):
	  _search_methods must return a SearchResult. (closes #425)

Tue Aug 12 17:52:13 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/refsdatabase.rb: reduce warnings.

	* lib/bitclust/entry.rb: ditto.

	* lib/bitclust/methoddatabase.rb: ditto.

Tue Aug 12 17:49:46 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/entry.rb: use better error message. (closes #424)

Tue Aug 12 17:31:51 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: fork methoddatabase.rb.

	* lib/bitclust/methoddatabase.rb: new file.

	* lib/bitclust/functiondatabase.rb: inherit Database class, to
	  provide #propget.  It is required to get work C-API reference.
	  (refs #422)

	* lib/bitclust/searcher.rb: Database -> MethodDatabase.

	* lib/bitclust/rrdparser.rb: ditto.

	* bin/bitclust.rb: ditto.

Tue Aug 12 17:29:31 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/completion.rb: implement class+type search.
	  (fixes #423)

	* lib/bitclust/completion.rb: class name only search did not work.

Tue Aug 12 09:27:30 2008  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (#search_method): result may not have
	  any class.

	* lib/bitclust/completion.rb (#expand_method_name): should not
	  return nil.

2008-06-30  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* standalone.rb: allow without --database option when with --auto
	  option.

	* packer.rb: remove default_version and --database option in server.rb.

2008-06-30  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* lib/bitclust/screen.rb, lib/bitclust/requesthandler.rb: error
	  response should not be 200 OK. see #204

2008-06-29  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: update default_version from "1.8.6" to "1.8.7".

2008-06-29  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/simplesearcher.rb (BitClust::SimpleSearcher::search_pattern): 
	  Fixed #204

	* lib/bitclust/requesthandler.rb (BitClust::RequestHandler::handle_search): 
	  ditto.

	* test/test_simplesearcher.rb (TestSearcher::test_simple_search): 
	  new assertions.

2008-06-29  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/simplesearcher.rb (BitClust::SimpleSearcher::search_pattern): 
	  should check whether pat includes only white spaces.

	* test/test_rrdparser.rb (TestRRDParser::test_title): 
	  new test.

	* test/test_simplesearcher.rb (TestSearcher::test_simple_search): 
	  ditto.

2008-06-28  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* tools/bc-tohtml.rb (main): fix a bug.

2008-06-25  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* template/method: fix heading levels.
	* template/doc: ditto.

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser::RRDParser.split_doc): 
	  split the title and the other.
	* lib/bitclust/database.rb (BitClust::Database::copy_doc): 
	  ditto.

2008-06-22  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/requesthandler.rb (BitClust::RequestHandler::handle_search): 
	  use String#scan. use appropriate regexp.

	* lib/bitclust/simplesearcher.rb (BitClust::SimpleSearcher::find_class): 
	  should escape strings in regexps.

Sun Jun 22 00:30:59 2008  Minero Aoki  <aamine@loveruby.net>

	* bin/refe.rb: automatically add command-relative libdir to the
	  load path.

	* bin/refe.rb: automatically set $KCODE to 'EUC' on Ruby 1.8
	  (tmp).

2008-06-21  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* theme/default/style.css: 
	  add margin to orderd lists.
	  change font-size of h4.

2008-06-19  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/preprocessor.rb (BitClust::Preprocessor::self.read): 
	  should use wrap.

2008-06-16  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* template/doc: minor edit.

2008-06-14  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::read_paragraph): 
	  in regexp, should use //emlist\{ instead of //\w.
	
	  (BitClust::RDCompiler::read_method_entry_paragraph): ditto.

	* test/test_rdcompiler.rb (TestRDCompiler::test_invalid_case): 
	  new test.

2008-06-11  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* tools/bc-tochm.rb: refm.chm now includes other documents.

2008-06-10  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: generate refe-{1_8_6,1_9_0}{,.cmd}.

2008-06-09  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/screen.rb (BitClust::TemplateScreen::initialize): 
	  set the encoding of the database to default_encoding.

	* template: add `Home' to each breadcrumb navigation.

2008-06-08  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/screen.rb (BitClust::URLMapper::search_url): 
	  new method.

	* test/test_refsdatabase.rb (Test_RefsDatabase::test_make_refs): 
	  new test.

2008-06-08  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* test/test_rdcompiler.rb (TestRDCompiler::test_braket_link): 
	  add new assertions.

2008-06-08  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* tools/bc-tohtml.rb (main): 
	  should pass the database to ScreenManager.entry_screen.

	* lib/bitclust/database.rb (BitClust::Database::Database.dummy): 
	  set Database#refs for dummy databases.

2008-06-08  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* tools/bc-tochm.rb (main): 
	  delete ScreenManagerEx. use ScreenManager.
	  should pass the database to ScreenManager.entry_screen and others.

	* lib/bitclust/screen.rb (BitClust::ScreenManager::initialize): 
	  should not overwrite given configuration.
	
	  (BitClust::TemplateScreen::initialize): ditto.

2008-06-08  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/requesthandler.rb (BitClust::RequestHandler::handle_class): 
	  pass the database to screen objects through the second argument.

	  (BitClust::RequestHandler::handle_doc): ditto.
	  (BitClust::RequestHandler::handle_search): ditto.
	  (BitClust::RequestHandler::handle_function): ditto.
	  (BitClust::RequestHandler::handle_method): ditto.
	  (BitClust::RequestHandler::handle_library): ditto.

	* lib/bitclust/screen.rb (BitClust::IndexScreen::initialize): 
	  now can take a database through the third argument.

	  (BitClust::EntryBoundScreen::initialize): ditto.
	  (BitClust::MethodScreen::initialize): ditto.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/database.rb (BitClust::Database::make_refs): 
	  Database now contains references in method entries.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::reference_link): 
	  new method. create a link from a reference ([[ref:c:String#m17n]] ...etc).

	  (BitClust::RDCompiler::bracket_link): 
	  bracket_link now can take a label and a fragment.
	  bracket_link now can treat [[ref:c:String#m17n]] ...etc.

	  (BitClust::RDCompiler::h): now can take a fragment.

	* lib/bitclust/htmlutils.rb (BitClust::HTMLUtils::library_link): 
	  now can take a fragment. 

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::document_link): 
	  new method. create a link to a document.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/exception.rb (BitClust::DocNotFound): 
	  new error class.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/screen.rb (BitClust::DocScreen): 
	  BitClust now can display documents.

	* lib/bitclust/entry.rb (BitClust::DocEntry): 
	  ditto.

	* lib/bitclust/requesthandler.rb (BitClust::RequestHandler::handle_doc): 
	  ditto.

	* template/doc: ditto.

	* template.offline/doc: ditto.

	* tools/bc-tohtml.rb (main): ditto.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/database.rb (BitClust::Database::docs): 
	  Database now can contain documents.

	  (BitClust::Database::make_refs): 
	  new method. make the database of references.

	  (BitClust::Database::copy_doc): 
	  new method. copy documents.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser::RRDParser.title): 
	  new method. extract the title of a document.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/refsdatabase.rb (BitClust::RefsDatabase): 
	  add a new reference-database class.

	* test/test_refsdatabase.rb (Test_RefsDatabase): ditto.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/completion.rb (BitClust::SearchResult::inspect): 
	  avoid too big SearchResult#inspect.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/preprocessor.rb (BitClust::Preprocessor::Preprocessor.read): 
	  add a File.read-like method.

2008-06-07  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/simplesearcher.rb (BitClust::SimpleSearcher::search_pattern): 
	  check whether pattern is empty.

2008-06-02  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* lib/bitclust/screen.rb (BitClust::ScreenManager):
          use a hash to store configuration data.

	* lib/bitclust/screen.rb (BitClust::TemplateScreen::search_form):
	  check whether called by bc-tochm.rb.

	* tools/bc-tochm.rb (main): ditto.

	* template/class (ancestors): ditto.

2008-06-01  okkez  <okkez000@gmail.com>

	* tools/bc-tochm.rb (main):
	  bc-tochm now can display target ruby version.

2008-06-01  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* standalone.rb: add default_encoding to the manager.

2008-06-01  TAMURA Takashi  <sh@sheepman.sakura.ne.jp>

	* template/search: BitClust now takes a search query.

	* template/class-index: ditto.

	* template/function-index: ditto.

	* template/function: ditto.

	* template/library-index: ditto.

	* template/library: ditto.

	* template/class: ditto.

	* template/method: ditto

	* theme/default/style.css: ditto.

	* lib/bitclust/screen.rb (BitClust::ScreenManager::seach_screen): ditto.
	(BitClust::TemplateScreen::search_form): ditto.
	(BitClust::SearchScreen::initialize): ditto.

	* lib/bitclust/requesthandler.rb (BitClust::RequestHandler::handle_search): ditto.

	* lib/bitclust/simplesearcher.rb (BitClust::SimpleSearcher): ditto.

	* test/test_simplesearcher.rb (TestSearcher::test_simple_search): add a new test.

	* test/test_entry.rb: minor edit.

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser.parse): 
	  add a new class method for debug.

2008-05-29  okkez  <okkez000@gmail.com>

	* lib/bitclust/screen.rb (BitClust::ScreenManager::new_screen):
	  BitClust now can display ruby version (from database property).

	* standalone.rb: ditto.

	* template/class: ditto.

	* template/method: ditto.

	* template/function: ditto.

	* template/function-index: ditto.

	* template/library-index: ditto.

	* template/library: ditto.

2008-05-25  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/requesthandler.rb (BitClust::RequestHandler::handle_class):
	  BitClust now can display methods of ancestors in template/class pages.

	* lib/bitclust/screen.rb (BitClust::ScreenManager::class_screen): ditto.

	* template/class: ditto.

	* lib/bitclust/entry.rb (BitClust::ClassEntry::entries): 
	  ClassEntry#entries now takes the depth of recursion.

	* test/test_entry.rb: ditto.

2008-05-24  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* template/class:  allow the case that spaces don't exist between a signature and `{'

	* tools/bc-rdoc.rb: should use ``require 'bitclust/ridatabase' ''

	* tools/bc-methods.rb: take constants into a list when diff.

	* test_nameutils.rb: add a test.

2008-05-01  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: File.expand_path path arguments.

2008-02-17  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: mkpath File.join(output_path, bitclust_dest_dir) instead
	  of output_path.

2008-01-26  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* tools/bc-methods.rb (defined_methods): 
	  should treat Object and Kernel as special cases.

	* tools/bc-methods.rb : add a new option `--ruby='.

	* lib/bitclust/crossrubyutils.rb (BitClust::CrossRubyUtils::get_ruby): 
	  add a new method that return the ruby interpreter path of a given version.

2008-01-05  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler): 
	  fix parsing at @param separated by empty lines.

	* test/test_rdcompiler.rb (TestRDCompiler::test_dlist): 
	  ditto.

2008-01-02  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler): 
	  refactoring.
	  fix the regexp of bracket link.

	* test/test_rdcompiler.rb (TestRDCompiler): 
	  ditto.

2008-01-01  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler):
	  use dlist for @param, @raise and so on.

	* test/test_rdcompiler.rb (TestRDCompiler::test_method): 
	  ditto.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler::dlist):
	  allow nested pre (//emlist{) in dlist.
	  use <p> in <dd>. empty lines separate paragraphs in dlist.

	* test/test_rdcompiler.rb (TestRDCompiler): ditto.

2007-12-31  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* test/test_rdcompiler.rb (TestRDCompiler): 
	  add new tests.

2007-12-30  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* test/test_rdcompiler.rb (TestRDCompiler): 
	  add new tests.

2007-12-29  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* test/test_rdcompiler.rb (TestRDCompiler): 
	  add new assertions.

2007-12-27  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/nameutils.rb (BitClust::NameUtils::libname2id): 
	  fix regexp for redefinable not operator. a patch from Yugui 
	  [ruby-reference-manual:660].

	* test/test_nameutils.rb (TestNameUtils::test_methodname): ditto
	
2007-12-26  IWATSUKI Hiroyuki  <don@na.rim.or.jp>

	* tools/bc-tochm.rb (main): add alias method names to keyword page.

2007-12-25  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: generate readme.html.

	* standalone.rb: use readme.html if exists.

	* lib/bitclust/database.rb: do not write db files as CRLF.

2007-12-24  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* test/test_rdcompiler.rb: add a new test.

Mon Dec 24 17:13:12 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb (encoding): had failed when
	  @entries.first is nil.

2007-12-24  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* test/test_preprocessor.rb (TestPreprocessor::test_eval_cond): 
	  add new assertions.

	* lib/bitclust/parseutils.rb: add a new require.

2007-12-23  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/preprocessor.rb (BitClust::Preprocessor::eval_expr): 
	  make conjunctions(and, or) available.

	* test/test_preprocessor.rb: add a new test.

2007-12-18  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* template/*: escape entry names. [ruby-reference-manual:607]

	* lib/bitclust/entry.rb (BitClust::Entry::Property::deserializer): 
	  fix [ruby-reference-manual:454].

2007-12-16  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/database.rb (BitClust::Database::Database.dummy): 
	  dummy databases should have version info.

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser::RRDParser.parse_stdlib_file): ditto

2007-12-13  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser::Context::define_class): 
	  top class is BasicObject in 1.9.0

2007-11-26  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* template/library: display Required Libraries and Sublibraries.

	* template.offline/library: ditto.

	* template/library-index: remove an adhoc indexing. do not display libraries that are sublibraries.

	* template.offline/library-index: ditto.

	* lib/bitclust/database.rb (Bitclust::Database::update_requires): LibraryEntry#requires should 
	  include all the required libraries recursively.

	* lib/bitclust/database.rb (BitClust::Database::transaction): call update methods.

	* lib/bitclust/database.rb (BitClust::Database): add new methods, Database#update_requires 
	  and Database#update_sublibraries.

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser::do_parse): add a new command `sublibrary'.

	* lib/bitclust/entry.rb (LibraryEntry): add new properties, LibraryEntry#sublibraries and 
	  LibraryEntry#is_sublibrary.

	* lib/bitclust/entry.rb (LibraryEntry): add new methods, LibraryEntry#sublibrary and 
	  LibraryEntry#all_requires.

2007-11-25  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* template/class: fix a regexp to split signatures of Added Methods. 

	* template/method: put `$' in the cases of global variables.

	* template.offline/method: ditto

2007-11-24  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* template/class: fix a regexp to split signatures of methods.

2007-11-23  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* template/library: do not display classes in required libraries

2007-11-15  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* tools/bc-preproc.rb (main): fix typo

	* lib/bitclust/preprocessor.rb (BitClust::Preprocessor::next_line): should check cond also when #@include

2007-11-10  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/rrdparser.rb (BitClust::RRDParser.parse_stdlib_file): add a new argument `params'.

	* lib/bitclust/screen.rb (BitClust::RDFileScreen): minor edit.

	* lib/bitclust/rdcompiler.rb (BitClust::RDCompiler): add a new instance variable `@option'.

	* template.offline/rd_file: minor edit

	* tools/bc-tohtml.rb (main): add new options, --force and --ruby_version.

2007-11-08  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/screen.rb (BitClust::RDFileScreen): add a new class for general RD files.

	* tools/bc-tohtml.rb (main): a new feature of compiling general RD files.

	* template.offline/rd_file: add a new template for general RD files.

	* template.offline/class: fix the url of a css file.

2007-11-07  TAMURA Takashi  <sheepman@sheepman.sakura.ne.jp>

	* lib/bitclust/ridatabase.rb (RiDatabase): take out RiDatabase from tools/bc-rdoc.rb.

	* tools/bc-methods.rb (main): display RDoc domcuments of entries that do not exist in Rurima.

	* template.offline/class: display all the methods in a single page. [ruby-reference-manual:557].

	* template/library: separate classes into Exception ones and others.

Wed Nov  7 01:47:22 2007  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: --database-version -> --database-versions.
          remove --database-dir.

	* standalone.rb: add new option --auto and --browser.

Sun Nov  4 19:37:37 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/preprocessor.rb: new conditional statement #@until.

	* lib/bitclust/rdcompiler.rb: new alias @arg (== @param).

Sat Oct 13 05:59:03 2007  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: create archive files.

Tue Oct  9 12:08:50 2007  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* packer.rb: new file.

	* standalone.rb: add new option --bind-address.

Thu Aug  9 01:41:19 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb (method_info): @see accepts comma
	  separated ref list.

Thu Aug  9 01:23:23 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb (method_info): compile @see.

Wed Aug  8 06:42:44 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb (method_info): change output (tmp).

Wed Aug  8 06:38:11 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: compile @return, @param, ...

Mon Aug  6 03:36:02 2007  Minero Aoki  <aamine@loveruby.net>

	* tools/stattodo.rb: use history database.

	* tools/ToDoHistory: add database file for backup.

	* lib/bitclust/rrdparser.rb: fork preprocessor.rb and
	  parseutils.rb.

	* lib/bitclust/preprocessor.rb: new file.

	* lib/bitclust/parseutils.rb: new file.

Sun Jul  1 18:45:03 2007  Minero Aoki  <aamine@loveruby.net>

	* standalone.rb: now --srcdir is optional.

Sun Jul  1 18:19:41 2007  Minero Aoki  <aamine@loveruby.net>

	* standalone.rb: --cgidir -> --themedir.

Sun Jul  1 18:09:56 2007  Minero Aoki  <aamine@loveruby.net>

	* standalone.rb: new file.  WEBrick based server entry point.

	* lib/bitclust/interface.rb: support WEBrick servlet (still
	  multi-thread unsafe).

Sun Jun 17 04:40:59 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/functionreferenceparser.rb: parse function header.

	* lib/bitclust/entry.rb (FunctionEntry): new persistent attribute
	  "filename".

	* template/function: show static and macro symbol.

Sat Jun  9 16:44:00 2007  Minero Aoki  <aamine@loveruby.net>

	* template/function: new file.

	* template/function-index: new file.

	* bin/bitclust.rb: support function database.

	* lib/bitclust/requesthandler.rb: ditto.

	* lib/bitclust/screen.rb: ditto.

	* lib/bitclust/database.rb: new class FunctionDatabase.

	* lib/bitclust/database.rb: new module DirectFileAccess.

	* lib/bitclust/entry.rb: new class FunctionEntry.

	* lib/bitclust/htmlutils.rb: new method #function_link.

	* lib/bitclust/nameutils.rb: new method #functionname?.

	* lib/bitclust/exception.rb: new exception class FunctionNotFound.

	* lib/bitclust/functionreferenceparser.rb: new file.

Sun May  6 21:30:56 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb (method_entry_paragraph): last change
	  was incomplete.

Sun May  6 19:48:40 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: support [[m:Array#[] ]].
	  [ruby-reference-manual:405]

	* tools/bc-tohtml.rb: --target=C did not work.

	* lib/bitclust/screen.rb: accept multiple method entries.

	* lib/bitclust/entry.rb: new method LibraryEntry#get_class.

	* lib/bitclust/entry.rb: new method LibraryEntry#fetch_methods.

Sun Apr 22 14:55:03 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/entry.rb (inherited_method_specs): did not reject
	  methods of the current class (Local variable was wrongly
	  overwritten).

	* bin/bitclust.rb: new subcommand "query".

Sun Apr 22 14:35:19 2007  Minero Aoki  <aamine@loveruby.net>

	* template/method: show all method entries.

	* lib/bitclust/screen.rb (MethodScreen): accept multiple entries.

	* lib/bitclust/requesthandler.rb: search all methods.

	* lib/bitclust/database.rb: new method Database#fetch_methods.

	* lib/bitclust/entry.rb: new method ClassEntry#fetch_methods.

	* template/class: parameterize entry type name.

	* lib/bitclust/screen.rb (h): call to_s for argument.

	* lib/bitclust/entry.rb (ClassEntry#inherited_method_specs): names
	  must be unique.

Sun Apr 22 13:35:14 2007  Minero Aoki  <aamine@loveruby.net>

	* template/method: parameterize method entry type label (instance
	  method, ...)

	* lib/bitclust/entry.rb: new method MethodEntry#type_label.

	* lib/bitclust/entry.rb: new method MethodEntry#short_label.

	* lib/bitclust/entry.rb (label): do not include class name for
	  variables.

	* lib/bitclust/htmlutils.rb (link_to_method): use #short_label.

Sun Apr 22 13:10:56 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/requesthandler.rb (handle_method): check gvar name
	  indivisually. [ruby-reference-manual:398]

	* lib/bitclust/nameutils.rb: new method #gvarname?.

Thu Mar 29 11:49:54 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb: new method ErrorScreen#content_type.

Thu Mar 29 06:34:49 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/lineinput.rb: import latest version.

Tue Mar 20 16:38:28 2007  Minero Aoki  <aamine@loveruby.net>

	* template/method: show visibility on topic path.

Tue Mar 20 16:19:06 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/completion.rb: cref includes class ID, not class
	  name.

Tue Mar 20 16:11:54 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/entry.rb (LibraryEntry#<=>): case-insensitive.

	* lib/bitclust/entry.rb (MethodEntry#<=>): defined entry preceeds
	  other entries.

	* lib/bitclust/entry.rb (MethodEntry#spec, spec_string, typemark,
	  typechar): optimize.

	* lib/bitclust/nameutils.rb: new method methodid2typechar.

	* lib/bitclust/nameutils.rb: new method methodid2typemark.

	* lib/bitclust/nameutils.rb: new method methodid2specparts.

	* lib/bitclust/nameutils.rb: rename methodid2spec ->
	  methodid2specstring.

	* lib/bitclust/htmlutils.rb: ditto.

	* lib/bitclust/nameutils.rb (typechar2mark, typemark2char):
	  optimize.

Tue Mar 20 02:04:38 2007  Minero Aoki  <aamine@loveruby.net>

	* template/library-index: show abstract of each entries.

	* template/library: ditto.

	* template/class: ditto.

	* lib/bitclust/screen.rb: new method Screen#foreach_method_chunk.

	* lib/bitclust/methodid.rb: new method MethodSpec#<=>.

	* lib/bitclust/rdcompiler.rb: $VAR should be rendered as "$VAR",
	  not "Kernel$VAR".

	* lib/bitclust/entry.rb (synopsis_source): might be nil.

	* lib/bitclust/entry.rb (partitioned_entries): separate added
	  entries.

	* lib/bitclust/lineinput.rb: new method LineInput.for_string.

	* theme/default/style.css: add table/tr/th/td rules.

Mon Mar 19 23:44:04 2007  Minero Aoki  <aamine@loveruby.net>

	* template/library: show added/redefined methods.

	* lib/bitclust/htmlutils.rb (link_to_method): add 2nd parameter
	  "specp".

	* lib/bitclust/entry.rb: new method Entry#detail_source.

Mon Mar 19 22:50:51 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/completion.rb: never load MethoEntry until needed.

	* bin/refe.rb: require specific library for speed.

	* lib/bitclust/searcher.rb: do not require bitclust/server
	  (webrick/config) until needed.

	* lib/bitclust/server.rb: include DRbUndumped to all classes here.

	* lib/bitclust/entry.rb: ditto.

	* lib/bitclust/database.rb: ditto.

Mon Mar 19 17:38:26 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb: reduce remote call.

	* lib/bitclust/database.rb: fork completion.rb.

	* lib/bitclust/completion.rb: new file.

	* lib/bitclust/entry.rb: combine _*map into _index.

	* lib/bitclust/methodid.rb: merge methodnamepattern.rb.

	* lib/bitclust/methodnamepattern.rb: removed (merged to
	  methodid.rb).

	* lib/bitclust/rdcompiler.rb: read method property.

Sat Mar  3 02:43:14 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb: support remote database.

	* lib/bitclust/database.rb: new method Database.connect to connect
	  to remote database.

	* lib/bitclust/server.rb: new file.

	* lib/bitclust/exception.rb: new exception class InvalidScheme.

	* lib/bitclust.rb: require bitclust/server.

	* bin/refe.rb: do not exit in SIGPIPE signal handler not to stop
	  druby server.

Sat Mar  3 00:16:46 2007  Minero Aoki  <aamine@loveruby.net>

	* tools/bc-tohtml.rb: new option --baseurl.

	* tools/bc-tohtml.rb: pass base_url and default_encoding to a
	  ScreenManager. [ruby-reference-manual:358]

	* lib/bitclust/screen.rb: accept new option default_encoding.

Tue Feb 20 09:44:39 2007  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb (main): just ignore SIGPIPE (and rescue EPIPE).

Wed Feb  7 22:05:12 2007  Minero Aoki  <aamine@loveruby.net>

	* move bin/bc-*.rb and forall-ruby.rb to tools/.

Fri Jan 26 06:39:46 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (make_method_index): should be
	  inheritance-sensitive. (refe failed to search inherited methods)

	* lib/bitclust/database.rb (open_class): should overwrite existing
	  object.

	* lib/bitclust/database.rb (open_library): ditto (but not
	  validated).

Tue Jan  9 04:07:54 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (get_class, open_class): logic fix
	  again.

	* lib/bitclust/database.rb: reduce redundant system calls.

	* lib/bitclust/entry.rb: ditto.

	* lib/bitclust/rrdparser.rb: supress warning on class alias.

Tue Jan  9 03:21:57 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (get_class): id is nil in else clause.

	* lib/bitclust/database.rb (load_class): set @classmap here.

Tue Jan  9 02:27:02 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: lazy loading for class entries.

	* lib/bitclust/database.rb: generate class ID/name relation index.

	* lib/bitclust/methodnamepattern.rb: optimize using class index.

	* lib/bitclust/entry.rb: reduce warning on Ruby 1.9.

Tue Jan  9 00:34:41 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: allow looped require (tmp).

	* lib/bitclust/rrdparser.rb: allow blank lines before class alias.

Tue Jan  9 00:21:02 2007  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: show program name in error message.

	* lib/bitclust/database.rb (transaction): check looped ancestors,
	  requires. [ruby-reference-manual:305]

	* lib/bitclust/entry.rb: ditto.

	* lib/bitclust/exception.rb: new exception InvalidLink.

	* lib/bitclust/exception.rb: new exception InvalidAncestor.

Sun Jan  7 16:47:14 2007  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb: chdir to document directory.

Sun Jan  7 14:45:04 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb (dlist): <dl></dl> location was wrong
	  (This patch is contributed by sheepman).
	  [ruby-reference-manual:289]

Sun Jan  7 14:43:49 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (properties): h['source'] may become
	  nil if database is empty (dummy).

Sat Jan  6 20:00:01 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: allow to write class alias (support
	  is still incomplete).

Fri Jan  5 08:47:50 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: produce better error message.

	* lib/bitclust/rrdparser.rb (read_classes): parse level-1 header
	  more strictly.

Fri Jan  5 07:12:14 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (read_classes): allow superclass for
	  level-1 object header.

Wed Jan  3 17:12:19 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: refactoring: extract method:
	  read_object_body.

Wed Jan  3 10:18:19 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (read_classes): allow dynamic include
	  (not implemented yet). [ruby-reference-manual:240]

	* lib/bitclust/rrdparser.rb (read_classes): allow extend for
	  modules/classes. [ruby-reference-manual:244]

Tue Jan  2 06:10:17 2007  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (check_chunk_signatures): allow not
	  qualified signature if method's signature is qualified and
	  compatible.

Tue Jan  2 06:09:00 2007  Minero Aoki  <aamine@loveruby.net>

	* tools/statrefm.rb: ignore not found files.

Tue Dec 19 08:27:14 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: allow <dl> out of method list.
	(This patch is contributed by sheepman.)

Tue Dec 19 08:26:40 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-methods.rb: expand module functions to instance/singleton
	  methods.

Wed Dec  6 19:32:23 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-methods.rb: new option --diff.

Wed Dec  6 19:32:04 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/statrefm.rb: do not count working file.

Mon Dec  4 21:56:40 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb (main): report Errno::ENOENT.

Sat Dec  2 21:40:48 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/statrefm.rb: new file.

Sat Dec  2 20:41:05 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb (InitCommand#exec): warn if standard properties
	  are not given.

	* lib/bitclust/rrdparser.rb: produce better error message.

Sat Nov 18 18:55:23 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: surround an error message by <span>.

	* theme/default/style.css: show error message by red, bold font.

Sat Nov 18 18:48:02 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb (blacket_link): protect compile
	  errors caused by wrong description.

Wed Nov 15 14:53:35 2006  Minero Aoki  <aamine@loveruby.net>

	* test/test_nameutils.rb (test_methodid2libid): should not decode
	  library ID.

Wed Nov 15 14:51:01 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: raise all exception on debugging.

	* lib/bitclust/methodnamepattern.rb: supress Ruby 1.9 warning.

	* lib/bitclust/methodid.rb (MethodID#match?): optimized.

	* lib/bitclust/nameutils.rb: define name regexps.

	* lib/bitclust/nameutils.rb (methodid2libid): should not decode
	  library ID.  [ruby-reference-manual:205]

	* lib/bitclust/rrdparser.rb: use regexps defined in nameutils.rb.

	* test: new directory.

	* test/test_nameutils.rb: new test.

Wed Nov 15 12:20:45 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/nameutils.rb (libname?): should allow '-'.
	  [ruby-reference-manual:205]

Tue Nov 14 21:45:41 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: new subcommand "bitclust property".

	* lib/bitclust/database.rb (transaction): save method index only
	  when some entry is modified.

	* lib/bitclust/database.rb (properties): should not include
	  "source" property (it is automatically added).

Tue Nov 14 21:31:23 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb (UpdateCommand#exec): use
	  Database#update_by_stdlibtree.

Tue Nov 14 00:53:14 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb (main): better help message.

	* tools/update-database.rb (send_message): fix typo.

Tue Nov 14 00:42:07 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb: add $LOAD_PATH hack.

Tue Nov 14 00:36:05 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: new method #update_by_stdlibtree.

Tue Nov 14 00:35:30 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb: old dbdir may not exist.

	* tools/update-database.rb: parents of dbdir may not exist.

Tue Nov 14 00:22:50 2006  Minero Aoki  <aamine@loveruby.net>

	* tools/update-database.rb: new file.

Mon Nov 13 21:03:12 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: should rescue errors caused by manual
	  reader/writer.

	* bin/bc-list.rb: ditto.

	* bin/bc-tohtml.rb: ditto.

	* bin/bc-preproc.rb: ditto.

	* lib/bitclust/exception.rb: new exception category WriterError.

	* lib/bitclust/exception.rb: rename class: CompileError ->
	  ParseError.

	* lib/bitclust/rrdparser.rb: rename method: #compile_error ->
	  #parse_error.

Mon Nov 13 17:31:28 2006  Minero Aoki  <aamine@loveruby.net>

	* config: introduce instance variables.

Mon Nov 13 17:06:53 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/nameutils.rb (split_method_id): library-ID may
	  include '.'. [ruby-reference-manual:201]

Sat Nov 11 09:23:44 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb: could not lookup Net::SMTP.
	  [ruby-reference-manual:197]

	* lib/bitclust/searcher.rb: new option --class.

Tue Nov  7 00:19:56 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: give better error message for wrong
	  #@include.

	* lib/bitclust/exception.rb: new execption class WrongInclude.

Tue Nov  7 00:08:12 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-tohtml.rb: check class for constant target.
	  [ruby-reference-manual:188]

	* lib/bitclust/methodid.rb: new method
	  MethodSpec#singleton_method?.

	* lib/bitclust/methodid.rb: new method
	  MethodSpec#instance_method?.

	* lib/bitclust/methodid.rb: new method
	  MethodSpec#module_function?.

	* lib/bitclust/methodid.rb: new method MethodSpec#method?.

	* lib/bitclust/methodid.rb: new method MethodSpec#constant?.

	* lib/bitclust/methodid.rb: new method
	  MethodSpec#special_variable?.

	* template/class: use block parameter |a,b| to expand [a,b].

Sat Nov  4 22:35:37 2006  Minero Aoki  <aamine@loveruby.net>

	* template/library-index: show topic path.

	* template/library: ditto.

	* template/class: ditto.

	* template/method: ditto.

	* template/method: show method kind (redefined/added).

	* lib/bitclust/rdcompiler.rb: new method compile_method, to show
	  kind.

	* lib/bitclust/screen.rb: new method
	  TemplateScreen#compile_method.

	* lib/bitclust/screen.rb: new method
	  TemplateScreen#library_index_url.

	* lib/bitclust/screen.rb: new method URLMapper#library_index_url.

	* theme/default/style.css: add kindinfo style.

	* theme/default/style.css: give more margin for <h2>, <dd>.

Sat Nov  4 22:22:29 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (load_extent): argument must be a
	  String. [ruby-reference-manual:184]

Sat Nov  4 21:07:22 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/nameutils.rb: support case-insensitive file
	  systems. [ruby-reference-manual:177]

	* lib/bitclust/nameutils.rb: fsencode -> encodename_url,
	  encodename_fs.

	* lib/bitclust/nameutils.rb: fsdecode -> decodename_url,
	  decodename_fs.

	* lib/bitclust/nameutils.rb: new method encodeid.

	* lib/bitclust/nameutils.rb: new method decodeid.

	* lib/bitclust/screen.rb: follow changes.

	* lib/bitclust/requesthandler.rb: ditto.

	* lib/bitclust/database.rb: ditto.

	* lib/bitclust/database.rb (realpath): encode ID before writing to
	  file system.

	* lib/bitclust/database.rb (entries): decode ID after reading from
	  file system.

Sat Nov  4 20:33:19 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-methods.rb (defined_methods): refactoring: extract
	  constant.

Sat Nov  4 20:31:46 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: show library ID for redefined/added methods.
	  [ruby-reference-manual:176]

Sat Nov  4 20:31:01 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/entry.rb: fix typo. [ruby-reference-manual:178]

Sun Oct 29 00:17:11 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-classes.rb: fork lib/bitclust/crossrubyutils.rb; use it.

	* bin/bc-methods.rb: ditto.

	* bin/forall-ruby.rb: ditto.

	* lib/bitclust/crossrubyutils.rb: new file.

Sat Oct 28 23:56:45 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-classes.rb: new option -v/--verbose.

	* bin/bc-classes.rb: should not raise exception on empty table.

	* bin/bc-classes.rb: add shebang line.

	* bin/bc-classes.rb: report if library does not exist.

Sat Oct 28 01:12:41 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: "=>" -> ">=".
	  [ruby-reference-manual:161]

Sat Oct 28 00:57:43 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb (describe_method): show all found
	  names.

Fri Oct 27 23:13:51 2006  Minero Aoki  <aamine@loveruby.net>

	* setup.rb: new file.

Fri Oct 27 22:54:35 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb: special variables must be searched by
	  "$...".

	* lib/bitclust/methodnamepattern.rb: support searching special
	  variable.

	* lib/bitclust/methodid.rb: new method MethodSpec#display_name.

Fri Oct 27 22:27:47 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb (show_methods): found name may be
	  multiple.

	* lib/bitclust/searcher.rb (describe_method): show all found
	  names.

	* lib/bitclust/searcher.rb (print_names): sort name list.

	* lib/bitclust/methodnamepattern.rb (MethodNamePattern): use
	  method name index.

	* lib/bitclust/methodnamepattern.rb (SearchResult::Record):
	  preserve found name and original name.

	* lib/bitclust/methodid.rb: now #type and #method is optional.

	* lib/bitclust/methodid.rb: new method MethodSpec#to_s.

	* lib/bitclust/methodid.rb: new method MethodSpec#==.

	* lib/bitclust/methodid.rb: new method MethodSpec#eql?.

	* lib/bitclust/methodid.rb: new method MethodSpec#hash.

	* lib/bitclust/database.rb: store method name index.

	* lib/bitclust/database.rb: new method Database#methods.

	* lib/bitclust/database.rb: new method Database#foreach_line
	  (internal use only).

	* lib/bitclust/database.rb (Database#entries): reject entry begin
	  with '='.

	* lib/bitclust/entry.rb: new method ClassEntry#get_methods.

	* lib/bitclust/entry.rb: #smap -> #_smap, #imap -> #_imap, and so
	  on.

	* lib/bitclust/entry.rb: new method MethodEntry#spec.

	* lib/bitclust/entry.rb: new method MethodEntry#spec_string.

Fri Oct 27 17:41:25 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/methodnamepattern.rb (select_classes): 'f' should
	  not be expanded to ['fatal'].

	* lib/bitclust/methodnamepattern.rb (Record): new method
	  #inherited_method?.

	* lib/bitclust/methodnamepattern.rb (Record): new method
	  #origin_classes.

	* lib/bitclust/searcher.rb: use Record's new methods.

	* lib/bitclust/searcher.rb: ',' means instance method, not
	  singleton.

Fri Oct 27 17:38:51 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/refe.rb: rescue errors on option parsing.

Fri Oct 27 17:17:44 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/methodid.rb: fork methodnamepattern.rb.

	* lib/bitclust/methodnamepattern.rb: new file.

	* lib/bitclust/database.rb: SearchPattern -> MethodNamePattern.

	* lib/bitclust/searcher.rb: ditto.

Mon Oct 23 21:35:22 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: update --stdlibtree process tree by LIBRARIES
	  file.

	* lib/bitclust/database.rb: export Database#properties.

Mon Oct 23 20:13:04 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/forall-ruby.rb: new file.

Mon Oct 23 19:45:25 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: now have subcommands instead of options.

	* bin/bc-rdoc.rb: --list option -> list subcommand.

	* bin/bc-rdoc.rb: --diff option -> diff subcommand.

	* bin/bc-rdoc.rb: new subcommand history.

Mon Oct 23 06:25:33 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: #list did not return right result.

Mon Oct 23 06:20:48 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: Win32 system does not have SIGPIPE.

	* bin/bc-rdoc.rb: ditto.

	* lib/bitclust/entry.rb: fix NoMethodError.

Sat Oct 21 04:36:41 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb (ListCommand): "bitclust list --library" output
	  was not sorted.

	* bin/bitclust.rb (LookupCommand): Ruby 1.9 does not have
	  String#map.

	* bin/bitclust.rb: print subcommand's help message when
	  subcommands failed.

	* lib/bitclust/searcher.rb: provide Searcher#parser for help
	  message.

	* lib/bitclust.rb: require 'bitclust/compat'.

	* lib/bitclust/compat.rb: provide String#lines.

Sat Oct 21 04:22:20 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/searcher.rb: search class if pattern begins with
	  capital letter.

	* lib/bitclust/searcher.rb: search class if pattern begins with
	  capital letter.

	* lib/bitclust/database.rb: Database#search_methods now returns a
	  SearchResult object.

	* lib/bitclust/methodid.rb: new method
	  SearchPattern#search_methods.

	* lib/bitclust/database.rb: fork methodid.rb and entry.rb.

	* lib/bitclust/methodid.rb: new file.

	* lib/bitclust/methodid.rb: rename class: MethodSpec -> MethodID.

	* lib/bitclust/rrdparser.rb: ditto.

	* lib/bitclust/methodid.rb: new class MethodSpec.

	* bin/bitclust.rb: use it.

	* bin/bc-tohtml.rb: ditto.

	* lib/bitclust/entry.rb: new file.

	* lib/bitclust/entry.rb: provide *Entry#<=>.

	* lib/bitclust/requesthandler.rb: now *Entry has <=>, simply use
	  sort.

	* template/library: ditto.

	* template/library-index: ditto.

	* template/class-index: ditto.

	* bin/bitclust.rb: trap(..., 'EXIT') causes success-exit, use
	  "exit 1" explicitly.

	* bin/refe.rb: ditto.

	* lib/bitclust/compat.rb: provide Object#__send.

	* lib/bitclust/compat.rb: provide Object#funcall.

Sat Oct 21 04:11:20 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/nameutils.rb: use '=' for class ID escaping,
	  instead of '__'.

Fri Oct 20 21:26:33 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/refe.rb: new file.

	* bin/bitclust.rb: new subcommand `search'.

	* lib/bitclust.rb: require 'bitclust/searcher'.

	* lib/bitclust/searcher.rb: new file.

	* lib/bitclust/database.rb: new method Database.datadir?.

	* lib/bitclust/database.rb: new method Database#search_method.

	* lib/bitclust/database.rb: new method SearchPattern#select_class.

	* lib/bitclust/database.rb: new method
	  SearchPattern#select_method.

	* lib/bitclust/database.rb: new method ClassEntry#name?.

	* lib/bitclust/database.rb: new method ClassEntry#name_match?.

	* lib/bitclust/database.rb: new method ClassEntry#label.

	* lib/bitclust/database.rb: new method ClassEntry#labels.

	* lib/bitclust/database.rb: rename method: MethodEntry#named? ->
	  name?.

	* lib/bitclust/database.rb: new method MethodEntry#name_match?.

	* lib/bitclust/database.rb: new method MethodEntry#labels.

	* lib/bitclust/database.rb: provide Object#__send if not exist.

	* lib/bitclust/exception.rb: new exception InvalidDatabase.

Fri Oct 20 21:22:56 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: suppress warning on -w.

Thu Oct 19 04:41:21 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb (ClassEntry#singleton_methods): returns
	  public/private methods, instead of public.

	* lib/bitclust/database.rb (ClassEntry#instance_methods): ditto.

Thu Oct 19 03:42:53 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb (ri_lookup_class): support nested class.

Thu Oct 19 02:32:58 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: new option --diff (and -d/--database).

	* lib/bitclust/database.rb: new method
	  ClassEntry#singleton_method?.

	* lib/bitclust/database.rb: new method ClassEntry#instance_method?

	* lib/bitclust/database.rb: new method ClassEntry#constant?

	* lib/bitclust/database.rb: new method
	  ClassEntry#special_variable?

	* lib/bitclust/database.rb: ClassEntry#singleton_method?,
	  #instance_method, #constant?, #special_variable?, #search_method,
	  #search_methods, #fetch_method have optional 2nd argument,
	  inherit.

	* lib/bitclust/database.rb: new method MethodEntry#named?.

	* lib/bitclust/rrdparser.rb: "<=>" method did not detected.

	* lib/bitclust/rrdparser.rb: does not provide superclass for
	  Object.

Wed Oct 18 23:53:52 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: ignore EPIPE.

Wed Oct 18 23:50:14 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: add shebang line.

Wed Oct 18 23:49:00 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-rdoc.rb: new file.

Mon Oct 16 02:24:10 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/nameutils.rb (classname?): allow 'fatal'

Sat Oct 14 01:50:12 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/requesthandler.rb: allow no class/library.

	* lib/bitclust/requesthandler.rb: show class index for path
	  "/class/".

	* lib/bitclust/database.rb: new method Database#fetch_library_id.

	* lib/bitclust/database.rb: new method Database#fetch_class_id.

	* lib/bitclust/nameutils.rb: new method methodname?.

	* lib/bitclust/nameutils.rb: new method typename?.

	* lib/bitclust/nameutils.rb: new method typechar?.

	* lib/bitclust/nameutils.rb: new method typemark?.

Sat Oct 14 01:30:38 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: support [[url:...]] syntax.

Sat Oct 14 01:08:30 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/requesthandler.rb: check method name strictly.

	* lib/bitclust/requesthandler.rb: check class name strictly.

	* lib/bitclust/requesthandler.rb: check library name strictly.

	* lib/bitclust/nameutils.rb: new method #libname?.

	* lib/bitclust/nameutils.rb: rename method: seems_class_name? ->
	  classname?.

	* lib/bitclust/nameutils.rb: rename method: seems_method_spec? ->
	  method_spec?.

	* lib/bitclust/exception.rb: rename class: KeyError -> InvalidKey.

	* bin/bc-tohtml.rb: ditto.

Sat Oct 14 00:13:22 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (Preprocessor): new directive #@todo.

Fri Oct 13 23:48:08 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: implement "bitclust lookup".

	* lib/bitclust/database.rb: remove MethodSpec.parse.

	* lib/bitclust/database.rb: new method SearchPattern.parse_spec.

	* lib/bitclust/database.rb (ClassEntry#special_variables): fix
	  typo.

	* lib/bitclust/textutils.rb: all methods are module function.

	* bin/bc-tohtml.rb: follow change.

Fri Oct 13 21:11:23 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: new link syntax [[man:tr(1)]],
	  [[RFC:2822]], [[ruby-list:12345]].

Fri Oct 13 20:39:40 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: method chain is better.

Fri Oct 13 20:38:04 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: _hashize_properties ->
	  _get_properties.

Fri Oct 13 20:28:49 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-tohtml.rb: implement --target command line option.

	* lib/bitclust/database.rb: new method LibraryEntry#fetch_class.

	* lib/bitclust/database.rb: new method LibraryEntry#fetch_method.

	* lib/bitclust/database.rb: new method MethodSpec.parse.

	* lib/bitclust/nameutils.rb: new method seems_class_name?.

	* lib/bitclust/nameutils.rb: new method seems_method_spec?.

	* lib/bitclust/nameutils.rb: all methods are module function.

	* lib/bitclust/exception.rb: new exception KeyError.

	* template/class: show module functions.

	* lib/bitclust/database.rb (ClassEntry#partitioned_entries):
	  should handle module functions.

	* lib/bitclust/database.rb (Database#get_library): argument is a
	  library name, not an ID.

	* lib/bitclust/database.rb (Database#get_class): argument is a
	  class name, not an ID.

	* lib/bitclust/database.rb (Entry): we must check @loaded to check
	  properties are loaded, should not see property ivar (e.g.
	  @superclass) because @superclass may be nil.

Fri Oct 13 20:21:09 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (RRDParser.libname): .off extension is
	  optional.

Fri Oct 13 20:18:08 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: show method details.

Fri Oct 13 20:13:15 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: ignore bitclust preprocessor directives.

Sat Oct  7 04:13:40 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (Preprocessor): last_if must be an
	  ivar, because #@if/#@since block is consist of multiple lines
	  (requires multiple next_line call).

Wed Sep 20 23:21:09 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (Preprocessor): change syntax: #@from
	  -> #@since.

Wed Sep 20 02:27:35 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: last change was incomplete.

Wed Sep 20 02:18:29 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb: URLMapper accepts library/class/method
	  name, not ID.

	* lib/bitclust/requesthandler.rb: A SearchPattern should include
	  method name, not ID.

	* lib/bitclust/rdcompiler.rb: use method spec to link to method
	  page.

	* lib/bitclust/database.rb (MethodEntry): extract @type, @library,
	  @klass from method ID instead of filesystem.

	* lib/bitclust/htmlutils.rb: causes least file loading.

	* lib/bitclust/nameutils.rb: add method ID/spec handling methods.

	* lib/bitclust/nameutils.rb (fsencode, fsdecode): use '=' instead
	  of '%'.

	* template/library: method_link_short -> link_to_method.

	* template/class-index: ditto.

	* template/method: show class and visibility.

Wed Sep 20 02:03:25 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-preproc.rb: new command.

	* lib/bitclust/rrdparser.rb (Preprocessor): new syntax "#@from".

Mon Sep 18 05:10:31 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: new method Entry#synopsis_source.

	* lib/bitclust/requesthandler.rb: sort entries before show.

	* lib/bitclust/rdcompiler.rb: surround method signature with
	  <code>.

	* lib/bitclust/screen.rb: entity -> entry.

	* template/library-index: link to libraries, classes.

	* template/library: show classes/modules, then classes/modules
	  with methods.

	* template/class-index: link to classes.

	* template/class: merge class-body.

	* template/class-body: merged in to template/class.

	* template/method: link to source library.

	* theme/default/style.css: use same color for visited link.

Mon Sep 18 04:21:05 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: new method Database#sorted_libraries,
	  sorted_classes.

	* lib/bitclust/database.rb: new method
	  LibraryEntry#sorted_classes, sorted_methods.

	* lib/bitclust/database.rb: new method ClassEntry#sorted_entries.

	* lib/bitclust/database.rb: new method
	  ClassEntry#partitioned_entries.

	* lib/bitclust/database.rb: new method
	  ClassEntry#(public_|private_)?(singleton_|instance_)?methods.

	* lib/bitclust/database.rb: new method ClassEntry#constants.

	* lib/bitclust/database.rb: new method
	  ClassEntry#special_variables.

	* lib/bitclust/database.rb: new method
	  MethodEntry#(public_|private_)?(singleton_|instance_)?method\?.

	* lib/bitclust/database.rb: new method MethodEntry#public?,
	  protected?, private?, really_public?.

	* lib/bitclust/database.rb: new method MethodEntry#fetch_method.

	* lib/bitclust/screen.rb: new methods URLMapper#library_url,
	  class_url, method_url.

	* lib/bitclust/rdcompiler.rb: compile links (still incomplete).

	* lib/bitclust/nameutils.rb: new method typemark2char.

	* lib/bitclust/textutils.rb: fork htmlutils.rb.

	* lib/bitclust/htmlutils.rb: new file.

Mon Sep 18 01:04:51 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: rename: entity -> entry.

Mon Sep 18 01:02:20 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: follow method name changes.

	* lib/bitclust/nameutils.rb: new method methodid2mname, to avoid
	  loading @names in MethodEntry#inspect.

	* lib/bitclust/database.rb: load properties before write.

	* lib/bitclust/rrdparser.rb: reopen/redefine block should not
	  include class documents or `include' statements.

	* lib/bitclust/rrdparser.rb: Signature#klass is a String.

Sun Sep 17 23:55:58 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: change database physical structure.

	* lib/bitclust/nameutils.rb (libid2name): fix unexpected infinite
	  recursion.

Sun Sep 17 21:51:36 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: forgot to change ivar @root -> lvar root.

	* lib/bitclust/database.rb: encode library ID.

	* lib/bitclust/database.rb: encode class ID.

	* lib/bitclust/nameutils.rb: new method libname2id.

	* lib/bitclust/nameutils.rb: new method libid2name.

	* lib/bitclust/nameutils.rb: new method classname2id.

	* lib/bitclust/nameutils.rb: new method classid2name.

Sun Sep 17 21:37:01 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: library.requires is a [LibraryEntry],
	  not a [String].

Sun Sep 17 21:21:34 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: new subcommand "bitclust list".

	* bin/bitclust.rb: new option "bitclust update --stdlibtree=PATH".

	* lib/bitclust/rrdparser.rb: allow level>3 headline for class
	  document.

Sun Sep 17 20:32:48 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: new subcommand "bitclust list".

Sun Sep 17 20:04:57 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: support special variables.

	* lib/bitclust/rrdparser.rb: better error message.

Sun Sep 17 18:24:29 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: message header should be program name, not file
	  name.

	* lib/bitclust/database.rb: new method Database#methodnames.

	* lib/bitclust/rrdparser.rb: @kind value changed.

	* lib/bitclust/rrdparser.rb: support "`" method.

Sun Sep 17 17:30:35 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: keep ((<ruby 1.* feature>)) in method
	  signature line.

Sun Sep 17 17:17:05 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: fix typo. Thanks: sheepman
	  [ruby-reference-manual:85]

	* bin/bc-list.rb: fix typo.

Fri Sep 15 23:42:53 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: new option -c,--check-only.

	* lib/bitclust/rrdparser.rb: fix small bug.

Fri Sep 15 23:31:57 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: implement `init' subcommand.

	* bin/bitclust.rb: implement `update' subcommand.

	* bin/bc-list.rb: more friendly output.

	* bin/bc-tohtml.rb: use new utility method parse_stdlib_file.

	* lib/bitclust/screen.rb: entity.encoding might return nil (using
	  dummy database).

	* lib/bitclust/rdcompiler.rb: toplevel may not be a method list.

	* lib/bitclust/rdcompiler.rb: support dlist (incomplete).

	* lib/bitclust/nameutils.rb: new file.

	* lib/bitclust/compat.rb: new file.

	* lib/bitclust/database.rb: implement lazy loading.

	* lib/bitclust/database.rb: implement save function.

	* lib/bitclust/database.rb: rename class: *Description -> *Entry.

	* lib/bitclust/database.rb: new class MethodSpec.

	* lib/bitclust/database.rb: new class SearchPattern.

	* lib/bitclust/database.rb: more and more changes/fixes.

	* lib/bitclust/rrdparser.rb: new util method
	  RRDParser.parse_stdlib_file.

	* lib/bitclust/rrdparser.rb: introduce new class Context.

	* lib/bitclust/requesthandler.rb: follow database interaface
	  change.

	* lib/bitclust/exception.rb: introduce new exceptions.

	* template/class-body: sort entries.

	* template/library: shorter output.

	* template/library-index: show class names.

	* template/method: better output.

	* template/method-body: removed.

Fri Sep 15 18:31:57 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: "self + other" wrongly converted to "+(o)".

Fri Sep 15 02:10:31 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/database.rb: temporary fix (allow private methods).

Thu Sep 14 17:25:20 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/screen.rb: new class LibraryIndexScreen.

	* lib/bitclust/screen.rb: new class ClassIndexScreen.

	* lib/bitclust/screen.rb: merge urlmapper.rb.

	* lib/bitclust/urlmapper.rb: removed (merged in to screen.rb).

	* lib/bitclust/interface.rb: fix typo.

	* lib/bitclust/requesthandler.rb

	* template/library-index: new file.

	* template/class-index: new file.

Thu Sep 14 16:41:33 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: commit miss.
	  (forgot to add receiver.)

Thu Sep 14 16:40:44 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: provide more detailed help.

Thu Sep 14 16:40:19 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-tohtml.rb: follow database method change.

Thu Sep 14 16:39:56 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rdcompiler.rb: forgot to add receiver.

Thu Sep 14 01:11:22 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bitclust.rb: new file.

	* lib/bitclust/database.rb: new method #transaction.

	* lib/bitclust/database.rb: new method #update_by_file.

	* lib/bitclust/rrdparser.rb: encapsulate preprocessor.

	* config: new file.

Thu Sep 14 01:06:37 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: parse command line options.

Thu Sep 14 01:01:15 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: ((<tr(1)|manual page>)) -> [[man:tr(1)]]
	  conversion was failed. [ruby-reference-manual:61]

Wed Sep 13 23:55:10 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb: support extend for objects.
	  [ruby-reference-manual:59]

	* lib/bitclust/database.rb (ClassDescription): store extended
	  modules.

Wed Sep 13 22:38:57 2006  Minero Aoki  <aamine@loveruby.net>

	* view.cgi: new file.

	* lib/bitclust.rb: remove bitclust/interface, it is required only
	  from entry point

Wed Sep 13 22:27:38 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-tohtml.rb: new file.

	* lib/bitclust/interface.rb: new file.

	* lib/bitclust/requesthandler.rb: new file.

	* lib/bitclust/screen.rb: new file.

	* lib/bitclust/urlmapper.rb: new file.

	* lib/bitclust/rdcompiler.rb: new file.

	* lib/bitclust/textutils.rb: new file.

	* lib/bitclust.rb: add above files.

	* lib/bitclust/database.rb: new class Entity.

	* lib/bitclust/database.rb: new method Entity#type_id.

	* lib/bitclust/database.rb: new method Entity#encoding.

	* lib/bitclust/database.rb: all entities should hold a Database.

	* lib/bitclust/rrdparser.rb: ditto.

	* lib/bitclust/exception.rb: new exception RequestError.

	* template/method: new file.

	* template/class-body: new file.

	* template/library: new file.

	* template/class: new file.

	* template/method-body: new file.

	* theme/default: new theme.

Wed Sep 13 17:34:35 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: should use RRDParser#parse_file.

	* lib/bitclust/rrdparser.rb: new method RRDParser#parse_file.

Wed Sep 13 17:33:08 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: should set $LOAD_PATH automatically.

Wed Sep 13 04:28:49 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: new option --inplace.

	* bin/bc-convert.rb: new option --diff.

Wed Sep 13 03:41:09 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: convert links.

	* bin/bc-convert.rb: convert comments.

Wed Sep 13 02:17:36 2006  Minero Aoki  <aamine@loveruby.net>

	* lib/bitclust/rrdparser.rb (Preprocessor): support #@include.

Wed Sep 13 00:54:34 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-convert.rb: new file.

Wed Sep 13 00:12:09 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: debug.

	* lib/bitclust/database.rb (MethodDescription#inspect): show entry
	  type.

Tue Sep 12 23:48:04 2006  Minero Aoki  <aamine@loveruby.net>

	* bin/bc-list.rb: new file.

Wed Aug 30 18:56:29 2006  Minero Aoki  <aamine@loveruby.net>

	* README: new file.

	* lib/bitclust/database.rb: new file.

	* lib/bitclust/exception.rb: new file.

	* lib/bitclust/rrdparser.rb: new file.

	* lib/bitclust/lineinput.rb: new file.

Wed Aug 30 08:14:26 2006  Minero Aoki  <aamine@loveruby.net>

	* start project.


